import request from '@/utils/request';
import { AxiosPromise } from 'axios';
import {MenuQuery, MenuVO, MenuForm, MenuTreeOption, RoleMenuTree, MenuVOEntity, MenuFormEntity} from './types';

// 权限页面菜单树
export const listResTree = (): AxiosPromise<MenuTreeOption[]> => {
    return request({
        url: '/sys/menu/listResTree',
        method: 'post'
    });
};


// 查询菜单列表
export const allMenuList = (query?: MenuQuery): AxiosPromise<MenuFormEntity[]> => {
  return request({
    url: '/sys/menu/allMenulist',
    method: 'post',
    data: query
  });
};


// 查询菜单列表
export const listMenu = (query?: MenuQuery): AxiosPromise<MenuVO[]> => {
  return request({
    url: '/sys/menu/listTree',
    method: 'post',
    data: query
  });
};

// 查询菜单列表
export const listAllMenu = (query?: MenuQuery): AxiosPromise<MenuVO[]> => {
  return request({
    url: '/sys/menu/listAllTree',
    method: 'post',
    data: query
  });
};


// 查询菜单详细
export const getMenu = (menuId: string | number): AxiosPromise<MenuVO> => {
  return request({
    url: '/system/menu/' + menuId,
    method: 'get'
  });
};

// 查询菜单下拉树结构
export const treeselect = (): AxiosPromise<MenuTreeOption[]> => {
  return request({
    url: '/system/menu/treeselect',
    method: 'get'
  });
};

// 根据角色ID查询菜单下拉树结构
export const roleMenuTreeselect = (roleId: string | number): AxiosPromise<RoleMenuTree> => {
  return request({
    url: '/system/menu/roleMenuTreeselect/' + roleId,
    method: 'get'
  });
};

// 根据角色ID查询菜单下拉树结构
export const tenantPackageMenuTreeselect = (packageId: string | number): AxiosPromise<RoleMenuTree> => {
  return request({
    url: '/system/menu/tenantPackageMenuTreeselect/' + packageId,
    method: 'get'
  });
};

// 新增菜单
export const addMenu = (data: MenuFormEntity) => {
  return request({
    url: '/sys/menu/save',
    method: 'post',
    data: data
  });
};

// 修改菜单
export const updateMenu = (data: MenuFormEntity) => {
  return request({
    url: '/system/menu',
    method: 'put',
    data: data
  });
};

// 删除菜单
export const delMenu = (menuId: string | number) => {
  return request({
    url: '/sys/menu/delete',
    method: 'post',
    data: {ids: [menuId]}
  });
};

//查询快捷菜单
export const getQuickMenus = () => {
    return request({
        url: '/sys/quick/menu/quickMenus',
        method: 'post',
    });
};

//查询所有
export const getAuthMenus = () => {
    return request({
        url: '/sys/quick/menu/listMenus',
        method: 'post',
    });
};
export const saveAuthMenus = (params: { menuIdls: (string | number)[], rangeType: number } = {menuIdls: [], rangeType: 1}) => {
    return request({
        url: '/sys/quick/menu/save',
        method: 'post',
        data: params
    });
};
///sys/menu/list_web_h5_res_tree 获取菜单资源树
export const listWebH5ResTree = (serviceModeType): AxiosPromise<MenuTreeOption[]> => {
    return request({
        url: '/sys/menu/list_web_h5_res_tree',
        method: 'post',
        data: {serviceModeType}
    });
};
